#include "__if.h"
#include "Exception.h"
#include <iostream>
#include "Operand.h"

namespace jet {

   __if::__if(coreutils::ZString &in, coreutils::MString &parentOut, Global &global, Tag *parent, Tag *local) : Tag(in, parentOut, global, parent, this, "else") {
      coreutils::MString result;
      bool booleanResult = false;
      if(keywordDefined("value1")) {
	 resolveKeyword("value1");
	 if(keywordDefined("expr"))
	   throw coreutils::Exception("Either value1 or expr can be specified but not both.");
	 if(keywordDefined("value2")) {
	    if(!keywordDefined("type")) 
	      throw coreutils::Exception("type expected if value1 and value2 specified.");
	 } else
	   throw coreutils::Exception("value2 required if value1 specified.");
	 resolveKeyword("value2");
	 resolveKeyword("type");
	 int rc = keywords["value1"].compare(keywords["value2"]);
	 if(((keywords["type"] == "eq") && (rc == 0)) ||
	    ((keywords["type"] == "ne") && (rc != 0)) ||
	    ((keywords["type"] == "lt") && (rc == -1)) || 
	    ((keywords["type"] == "le") && (rc != 1)) ||
	    ((keywords["type"] == "gt") && (rc == 1)) ||
	    ((keywords["type"] == "ge") && (rc != -1)))
	   booleanResult = true;
	 else
	   throw coreutils::Exception("type value must be 'eq','ne','lt','le','gt','ge'.");
      } else if(keywordDefined("expr")) {
	 if(keywordDefined("value2"))
	   throw coreutils::Exception("value2 should not be specified with expr.");
	 if(keywordDefined("type"))
	   throw coreutils::Exception("type should not be specified with expr.");
	 booleanResult = Operand(keywords["expr"], global, parent->variables).boolean;
      }
      if(booleanResult) 
	processContainer(container);
      else if(hasContainer2)
	processContainer(container2);
   }

}
